/*
 * This Java source file was generated by the Gradle 'init' task.
 */
package number2;

import java.util.*;


/**
* class for generating <b>maps</b>
* @author Sofia Iakovleva "sofja.iakovleva@gmail.com"
* @version 1.0
* @see Main
 */
public class Maps{
 /**
 * Field map
  */
  Map<String, Integer> map;
  /**
  * Сonstant SEC
  * {@value} Сreated to calculate the time
  *
  */
  final int SEC = 1000;
  /**
  * Сonstant LIMIT
  * {@value} Number of map values
  *
  */
  final int LIMIT = 2000000;

  /**
  * Сonstant GEN
  * {@value} For generate
  *
  */
  final int GEN = 100000;

  /**
  * Сonstant
  * {@value} For generate array
  *
  */
  final int MASS = 30000;

/**
* Сonstructor for maps
* @param map
 */
  Maps(Map<String, Integer> map){
    this.map = map;
    generateValues();
  }

/**
* Method for generating map keys
* @return generated string key(str)
 */
  public String generateKey(){
    double start = System.currentTimeMillis();
    Random random = new Random();
    String str = "";
    for (int i = 0; i < 10; i++){
      int key = random.nextInt(26);
      str = Integer.toString(key);
     }
     return str;
  }

/**
* Method for generating map values
*/
  public void generateValues(){
    for (int i = 0; i < LIMIT; i++){
      int value = (int)(Math.random() * GEN);
      this.map.put(generateKey(), value);
    }
  }

  public void time(){
    double start = System.currentTimeMillis();
    generateValues();
    double time = System.currentTimeMillis() - start;
    System.out.println("Time generatedValues: " + time/SEC + " sec");
  }

  /**
  * Metod for generate array with values
  * @return generate array
  */

  public String[] mass(){
    String[] mass = new String[MASS];
    for(int i = 0; i < MASS; i++){
      mass[i] = generateKey();
    }
    return mass;
  }
  /**
  * Method for calculating the sum of display values ​​corresponding to strings from an array
  * @param mass
  */
  public void sum(String[] mass){
    double start = System.currentTimeMillis();
    int sum = 0;

    for (int i = 0; i < MASS; i++){
      Integer values = this.map.get(mass[i]);
      if (values != null) {
        sum += values;
      }
    }

    double time = System.currentTimeMillis() - start;
    System.out.println("Amount values time: " + time/SEC + " sec");
    System.out.println("Amount: " + sum);
  }
}
